#!/usr/bin/env python

# enhance_shadows.py
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Version 1 02/03/2024
# 
#
#
#import Image
from gimpfu import *
def python_enhance_shadows(image, layer):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	Desaturate = pdb.gimp_layer_new_from_drawable(layer, image)								# make new layer to be named "Desaturate" (source, destination)
	pdb.gimp_image_insert_layer(image, Desaturate, None, 0)									# (image, layer, parent, position)		
	pdb.gimp_item_set_name(Desaturate, "Desaturate")										# name the layer
	pdb.gimp_drawable_desaturate(Desaturate, DESATURATE_LUMINANCE)							# (drawable, destination)
	pdb.gimp_drawable_invert(Desaturate, FALSE)												# invert desaturated layer
	pdb.gimp_layer_set_mode(Desaturate, LAYER_MODE_OVERLAY)									# change Desaturate layer to LAYER_MODE_OVERLAY
	pdb.gimp_layer_set_opacity(Desaturate, 50)												# set opacity 50%
	
	Lighten = pdb.gimp_layer_new_from_drawable(layer, image)								# copy original image to Colcast (source, destination)
	pdb.gimp_image_insert_layer(image, Lighten, None, 0)									# (image, layer, parent, position)
	pdb.gimp_item_set_name(Lighten, "Lighten")												# name the layer
	pdb.gimp_layer_set_mode(Lighten, LAYER_MODE_LIGHTEN_ONLY)								# change Lighten layer to LAYER_MODE_LIGHTEN_ONLY
	
	pdb.gimp_image_set_active_layer(image, Desaturate)										# make Desaturate layer active
		
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_enhance_shadows",
	"Enhance Shadows",
	"Enhance Shadows",
	"David Marsden",
	"David Marsden",
	"March 2024",
	"<Image>/Python-Fu/Enhance Shadows...",             									#Menu path
	"RGB*, GRAY*", 
	[],
	[],
	python_enhance_shadows)

main()
